Getting Started
===============
Hello, sinetone!!

- - -

en:- Code in documents can be run on <button style="width:40px">Play</button>.
en:- You can also directly modify the code, and experience fabulous `timbre.js`.
ja:- このドキュメントのコードは <button style="width:40px">Play</button> で実行することができます。
ja:- コードを直接変更することも出来ますので、timbre.js の便利さを今すぐ体感できます。

- - -

en: In timbre.js, programming is performed by combining the **T-Object** generated by `T()` function. T-object type is specified by a string as the first argument of the T-function. Below is a simple example of generating a sine wave. Sound is heard? Next, re-run after changing to `saw` from `sin`. You will hear different type of sound (sawtooth wave).
ja: timbre.js では関数 `T()` で生成される **T オブジェクト** を組み合わせてプログラミングを行ないます。T オブジェクトの種類は T 関数 の最初の引数として文字列で指定します。まずは簡単な使い方としてサイン波を出力してみましょう。音量に注意して実行してみてください。音が鳴ったら今度は `sin` の部分を `saw` と変更して実行してみてください。違う種類の音 ( のこぎり波 ) が鳴ります。

```timbre
T("sin").play();
```

en: The second argument specifies properties in the form of a dictionary. In the following example we set to play 880(Hz) the property of the sin-oscillator frequency.
ja: 二番目の引数には辞書形式でプロパティを指定します。以下の例ではサイン波を出力するオシレーターのプロパティを 880(Hz) に設定して再生しています。

```timbre
T("sin", {freq:880}).play();
```

en: `set()` is if you will specify properties later. In fact, the dictionary of the second argument is internally calling this method. The following example is almost the same as in the previous example.
ja: プロパティをあとから指定する場合は `set` メソッドを使用します。

```timbre
var sin = T("sin").play();

sin.set({freq:880});
```

en: Subsequent arguments are input objects. Most T-object is added to the value of input objects in front of its own processing. For example, an envelope object outputs the values that multiplied by values of input objects. In the following example, 
ja: 三番目以降には入力オブジェクトを記述します。ほとんどの T オブジェクト は自身の処理の前に入力オブジェクトの値を加算します。たとえばエンベロープオブジェクトでは自身の出力値と入力オブジェクトの値を積算して出力します。

```timbre
var sine1 = T("sin", {freq:440, mul:0.5});
var sine2 = T("sin", {freq:660, mul:0.5});

T("perc", {r:500}, sine1, sine2).on("ended", function() {
  this.pause();
}).bang().play();
```

- - -

en: ## The basic processing flow of the T-object ##
ja: ## Tオブジェクトの動作の流れ ##

en:- Adds the values ​​of the input object
en:- The calculation of attribute values
en:- Processing its own object
en:- And outputs the result
en:- The output value is the value/attribute of another T-object
ja:- 入力オブジェクトの値を加算する
ja:- 属性値の計算を行う
ja:- オブジェクト独自の処理を行う
ja:- 結果を出力する
ja:- 出力された値は別の Tオブジェクトの入力 / 属性値になる

ja: このようなシンプルな仕様に基づいて動作するため、柔軟なサウンド生成を簡単に行なうことが可能です。

```timbre
var freq = T("pulse", {freq:5, add:880, mul:20}).kr();

T("sin", {freq:freq, mul:0.5}).play();
```
